# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`mosquitto`](#mosquitto): Puppet module to manage the Eclipe Mosquitto MQTT server

#### Private Classes

* `mosquitto::config`: handle the Mosquitto configuration file
* `mosquitto::install`: Install mosquitto
* `mosquitto::service`: handles the Mosquitto service

## Classes

### <a name="mosquitto"></a>`mosquitto`

Puppet module to manage the Eclipe Mosquitto MQTT server

#### Parameters

The following parameters are available in the `mosquitto` class:

* [`manage_package`](#-mosquitto--manage_package)
* [`manage_service`](#-mosquitto--manage_service)
* [`package_ensure`](#-mosquitto--package_ensure)
* [`package_name`](#-mosquitto--package_name)
* [`service_ensure`](#-mosquitto--service_ensure)
* [`service_name`](#-mosquitto--service_name)
* [`service_enable`](#-mosquitto--service_enable)
* [`config`](#-mosquitto--config)

##### <a name="-mosquitto--manage_package"></a>`manage_package`

Data type: `Boolean`

Boolean to enable/disable package handling

Default value: `true`

##### <a name="-mosquitto--manage_service"></a>`manage_service`

Data type: `Boolean`

Boolean to enable/disable service handling

Default value: `true`

##### <a name="-mosquitto--package_ensure"></a>`package_ensure`

Data type: `Enum['latest', 'absent', 'present']`

ensure attribute for the package resource

Default value: `'present'`

##### <a name="-mosquitto--package_name"></a>`package_name`

Data type: `String[1]`

Name of the Mosquitto package

Default value: `'mosquitto'`

##### <a name="-mosquitto--service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`

the desired state of the service

Default value: `'running'`

##### <a name="-mosquitto--service_name"></a>`service_name`

Data type: `String[1]`

Name of the Mosquitto service

Default value: `'mosquitto'`

##### <a name="-mosquitto--service_enable"></a>`service_enable`

Data type: `Boolean`

wether the service should be in autostart or not

Default value: `true`

##### <a name="-mosquitto--config"></a>`config`

Data type: `Array[String[1]]`

list of config options for Mosquitto

Default value: `[]`

